'use strict';(function(exports){var LayoutManager=function LayoutManager(){};LayoutManager.prototype={DEBUG:false,CLASS_NAME:'LayoutManager',get clientWidth(){if(this._clientWidth){return this._clientWidth;}
this._clientWidth=document.documentElement.clientWidth;return this._clientWidth;},get height(){var activeApp=Service.currentApp;var isFullScreenLayout=activeApp&&activeApp.isFullScreenLayout();var softwareButtonHeight=Service.query('locked')||isFullScreenLayout?0:softwareButtonManager.height;var keyboardHeight=this.keyboardEnabled?inputWindowManager.getHeight():0;var keypadHeight=Service.query('KeypadEmulator.enabled')?200:0;if(softwareButtonManager.height||softwareButtonManager.width){var height=480-keypadHeight;}else{var height=window.innerHeight-keyboardHeight-softwareButtonHeight-keypadHeight;}
var dpx=window.devicePixelRatio;if((height*dpx)%1!==0){height=Math.ceil(height*dpx)/dpx;}
return height;},get width(){return window.innerWidth-
((Service.currentApp&&Service.currentApp.isFullScreenLayout())?0:softwareButtonManager.width);},getHeightFor:function(currentWindow,ignoreKeyboard){if(currentWindow instanceof AttentionWindow){var keyboardHeight=this.keyboardEnabled&&!ignoreKeyboard?inputWindowManager.getHeight():0;var keypadHeight=Service.query('KeypadEmulator.enabled')?200:0;var height=window.innerHeight-keyboardHeight-
softwareButtonManager.height-keypadHeight;if(softwareButtonManager.height||softwareButtonManager.width){height=480;}
var dpx=window.devicePixelRatio;if((height*dpx)%1!==0){height=Math.ceil(height*dpx)/dpx;}
return height;}
if(ignoreKeyboard){return this.height+inputWindowManager.getHeight();}else{return this.height;}},match:function lm_match(width,height){return(this.width===width&&this.height===height);},keyboardEnabled:false,_lastOrientation:undefined,start:function lm_start(){window.addEventListener('resize',this);window.addEventListener('keyboardchange',this);window.addEventListener('keyboardhide',this);window.addEventListener('mozfullscreenchange',this);window.addEventListener('fullscreenchange',this);window.addEventListener('software-button-enabled',this);window.addEventListener('software-button-disabled',this);window.addEventListener('attentionwindowmanager-deactivated',this);window.addEventListener('lockscreen-appclosed',this);window.addEventListener('keypad-enabled',this);window.addEventListener('keypad-disabled',this);this._lastOrientation=screen.mozOrientation;},handleEvent:function lm_handleEvent(evt){this.debug('resize event got: ',evt.type);switch(evt.type){case'keyboardchange':if(document.mozFullScreen){document.mozCancelFullScreen();}
this.keyboardEnabled=true;this.publish('system-resize');break;case'resize':if(!(screen.mozOrientation!==this._lastOrientation&&this.keyboardEnabled)){this.publish('system-resize');}
this.publish('orientationchange');this._lastOrientation=screen.mozOrientation;break;case'lockscreen-appclosed':if(softwareButtonManager.enabled){this.publish('system-resize');}
break;default:if(evt.type==='keyboardhide'){this.keyboardEnabled=false;}
this.publish('system-resize');break;}},publish:function lm_publish(event,detail){var evt=document.createEvent('CustomEvent');evt.initCustomEvent(event,true,false,detail||this);this.debug('publish: '+event);window.dispatchEvent(evt);},debug:function lm_debug(){if(this.DEBUG){console.log('['+this.CLASS_NAME+']'+'['+Service.currentTime()+'] '+
Array.slice(arguments).concat());}}};exports.LayoutManager=LayoutManager;}(window));